package com.tzld.piaoquan.recommend.server;

import com.tzld.piaoquan.recommend.feature.client.FeatureClient;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.EnableAspectJAutoProxy;

/**
 * https://github.com/grpc-swagger/grpc-swagger/blob/master/README_CN.md
 */
@SpringBootApplication
@ComponentScan({
        "com.tzld.piaoquan.recommend.server.service",
        "com.tzld.piaoquan.recommend.server.grpcservice",
        "com.tzld.piaoquan.recommend.server.remote",
        "com.tzld.piaoquan.recommend.server.config",
        "com.tzld.piaoquan.recommend.server.web"
})
@EnableEurekaClient
@EnableAspectJAutoProxy
public class Application {
    public static void main(String[] args) {
        SpringApplication.run(Application.class, args);

    }


    @Bean
    public FeatureClient featureClient() {
        return new FeatureClient();
    }
}

