package com.tzld.piaoquan.recommend.server.common.base;
import io.lettuce.core.StrAlgoArgs;
import lombok.Data;

import java.util.Map;

@Data
public class UserBytesFeature {

    private final byte[]  mid;
    private final byte[]  uid;

    // 当天统计量信息
    private Map<String, byte[]> day1_cnt_features;
    // 3天内统计量
    private Map<String, byte[]> day3_cnt_features;
    // 7天内统计量
    private Map<String, byte[]> day7_cnt_features;
    // 3个月统计量
    private Map<String, byte[]> month3_cnt_features;
    // 用户行为周期
    private final byte[]  user_cycle_bucket_7days;
    private final byte[]  user_cycle_bucket_30days;
    private final byte[]  user_share_bucket_30days;


    public UserBytesFeature(UserFeature userFeature) {
        mid = userFeature.getMid().getBytes();
        uid = userFeature.getUid().getBytes();
        user_cycle_bucket_7days = userFeature.getUser_cycle_bucket_7days().getBytes();
        user_cycle_bucket_30days = userFeature.getUser_cycle_bucket_30days().getBytes();
        user_share_bucket_30days = userFeature.getUser_share_bucket_30days().getBytes();


        // 1 day statistic
        day1_cnt_features.put("exp", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("click", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("share", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("return", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("ctr", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("str", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("rov", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());

        // 3 day statistic
        day1_cnt_features.put("exp", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("click", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("share", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("return", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("ctr", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("str", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("rov", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());

        // 7 day statistic
        day1_cnt_features.put("exp", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("click", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("share", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("return", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("ctr", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("str", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("rov", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());


        // 3 month statisic
        day1_cnt_features.put("exp", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("click", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("share", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("return", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("ctr", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("str", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());
        day1_cnt_features.put("rov", String.valueOf(userFeature.getDay1_cnt_features().getExp_cnt()).getBytes());

    }



}
