package com.tzld.piaoquan.recommend.server.common.base;

import com.tzld.piaoquan.recommend.server.model.Video;
import lombok.Data;

import java.util.Map;
@Data
public class VideoBytesFeature {
    private final byte[] videoId;

    private final byte[] upId;

    private final byte[] tags;

    private final byte[] title;

    private final byte[] titleLength;

    private final byte[] playLength;

    private final byte[] totolTime;

    private final byte[] daysSinceUpload;


    // 当天统计量信息
    private Map<String, byte[]> item_day1_cnt_features;
    // 3天内统计量
    private Map<String, byte[]> item_day3_cnt_features;
    // 7天内统计量
    private Map<String, byte[]> item_day7_cnt_features;
    // 3个月统计量
    private Map<String, byte[]> item_month3_cnt_features;

    public VideoBytesFeature(ItemFeature itemFeature) {
        videoId  = itemFeature.getVideoId().getBytes();
        upId  = itemFeature.getVideoId().getBytes();

        tags  = itemFeature.getTags().getBytes();
        title  = itemFeature.getTitle().getBytes();
        titleLength  = itemFeature.getTitleLength().getBytes();
        playLength  = itemFeature.getPlayLength().getBytes();
        totolTime  = itemFeature.getTotolTime().getBytes();
        daysSinceUpload  = itemFeature.getDaysSinceUpload().getBytes();
        // 1day
        item_day1_cnt_features.put("exp", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());
        item_day1_cnt_features.put("click", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());
        item_day1_cnt_features.put("share", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());
        item_day1_cnt_features.put("return", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());
        item_day1_cnt_features.put("ctr", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());
        item_day1_cnt_features.put("str", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());
        item_day1_cnt_features.put("rov", String.valueOf(itemFeature.getItem_day1_cnt_features().getExp_cnt()).getBytes());

        // 3day
        item_day3_cnt_features.put("exp", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("click", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("share", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("return", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("ctr", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("str", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("rov", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());


        // 7day
        item_day3_cnt_features.put("exp", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("click", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("share", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("return", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("ctr", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("str", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_day3_cnt_features.put("rov", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());



        // 3month
        item_month3_cnt_features.put("exp", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_month3_cnt_features.put("click", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_month3_cnt_features.put("share", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_month3_cnt_features.put("return", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_month3_cnt_features.put("ctr", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_month3_cnt_features.put("str", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());
        item_month3_cnt_features.put("rov", String.valueOf(itemFeature.getItem_day3_cnt_features().getExp_cnt()).getBytes());








    }

}
