package com.tzld.piaoquan.recommend.server.service.score.feature;

import com.tzld.piaoquan.recommend.server.common.base.*;
import com.tzld.piaoquan.recommend.server.common.enums.VlogFeatureGroup;
import com.tzld.piaoquan.recommend.server.gen.recommend.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class VlogShareLRFeatureExtractor extends LRBytesFeatureExtractorBase {

    public VlogShareLRFeatureExtractor() {
        super();
    }
    public VlogShareLRFeatureExtractor(FeatureUsage usage) {
        super(usage);
    }
    public VlogShareLRFeatureExtractor(FeatureUsage usage, double userCtrGroup, double videoCtrGroup) {
        super(usage, userCtrGroup, videoCtrGroup);
    }


    // TODO
    // 补充待抽取的context feature
    private void getContextFeatures(RequestContextBytesFeature requestContextBytes) {
        makeFea(VlogFeatureGroup.MACHINEINFO_BRAND, requestContextBytes.getMachineinfo_brand());
        makeFea(VlogFeatureGroup.MACHINEINFO_MODEL, requestContextBytes.getMachineinfo_model());
        makeFea(VlogFeatureGroup.MACHINEINFO_PLATFORM, requestContextBytes.getMachineinfo_platform());
        makeFea(VlogFeatureGroup.MACHINEINFO_SDKVERSION, requestContextBytes.getMachineinfo_sdkversion());
        makeFea(VlogFeatureGroup.MACHINEINFO_SYSTEM, requestContextBytes.getMachineinfo_system());
        makeFea(VlogFeatureGroup.MACHINEINFO_WECHATVERSION, requestContextBytes.getMachineinfo_brand());

        makeFea(VlogFeatureGroup.DAY, requestContextBytes.getWeek());
        makeFea(VlogFeatureGroup.WEEK, requestContextBytes.getWeek());
        makeFea(VlogFeatureGroup.HOUR, requestContextBytes.getHour());

    }

    //TODO
    private void getUserFeatures(UserBytesFeature user) {
        makeFea(VlogFeatureGroup.USER_CYCLE_BUCKET_7DAY,user.getUser_cycle_bucket_7days());
        makeFea(VlogFeatureGroup.USER_SHARE_BUCKET_30DAY,user.getUser_share_bucket_30days());
        makeFea(VlogFeatureGroup.USER_SHARE_BUCKET_30DAY,user.getUser_cycle_bucket_30days());

    }

    private void getItemFeature(VideoBytesFeature videoBytesFeature) {
        makeFea(VlogFeatureGroup.VIDEOID, videoBytesFeature.getVideoId());
        makeFea(VlogFeatureGroup.UP_ID, videoBytesFeature.getUpId());
    }

    @Override
    public synchronized LRSamples single(UserBytesFeature userBytesFeature,
                            VideoBytesFeature videoBytesFeature,
                            RequestContextBytesFeature requestContextBytesFeature) {
        features.clear();
        // extract features
        getUserFeatures(userBytesFeature);
        getContextFeatures(requestContextBytesFeature);
        getItemFeature(videoBytesFeature);


        LRSamples.Builder lr =  com.tzld.piaoquan.recommend.server.gen.recommend.LRSamples.newBuilder();
        lr.setGroupNum(groupCount);
        List<FeatureGroup> keys = new ArrayList<>(features.keySet());
        int count = 0;
        for(FeatureGroup group : keys) {
            List<BaseFeature> fea = features.get(group);
            GroupedFeature.Builder gf = GroupedFeature.newBuilder();
            gf.setGroup(group);
            gf.setCount(fea.size());
            gf.addAllFeatures(fea);
            count += fea.size();
            lr.addFeatures(gf);
        }
        lr.setCount(count);
        return lr.build();
    }












}
